//Jack's Best//
#ifndef SSalgorithm
#define SSalgorithm
namespace ShengjieSun {
  
std::vector<DensityMap> DenMB(MinMax& limit, double cs){
	std::vector<DensityMap>DenM;
  int x_range=(limit.x_max-limit.x_min)/cs+1;
  int y_range=(limit.y_max-limit.y_min)/cs+1;
  int z_range=(limit.z_max-limit.z_min)/cs+1;
  for (int i=0; i<x_range;i++){
   for (int j=0; j<y_range;j++){
    for (int k=0; k<z_range;k++){
     DensityMap map(i,j,k,0);
     DenM.push_back(map);  
    }
   }
  }
  return DenM;
 }

void trans (std::vector<DensityMap>& DenM,std::vector<ion3D>& ions, MinMax& limit, double cs){
	  for (auto& ion: ions){
  ion.refresh();
  ion.CalIndex(limit.x_min, limit.y_min, limit.z_min, cs);
//  ion.output();
    bool found=false;
    for (auto& map : DenM) {
        if (map.ix == ion.ix && map.iy == ion.iy && map.iz == ion.iz) {
            ++map.n;
	    found=true;
            break;
        } 
      }  
     if(!found){
	     std::cout<<RED<<"bizinga::There are some issues happened and SS is not sure!!! but it should be fine. "<<RESET<<std::endl;
        DensityMap map (ion.ix, ion.iy, ion.iz, 1);
        DenM.push_back(map);
   }   
  } 
}


void SaReIons (std::string iontype, std::string chainID, std::vector<DensityMap>& DenM, std::vector<ion3D>& ions,std::vector<ATOM>& Boundions, MinMax& limit, point3D targetframe, double cs,int threshold)
{
	std::cout<<"the threshold is "<<threshold<<std::endl;
	std::vector<DensityMap> DenMF;
	for (const auto & map : DenM){
	  if(map.n >= threshold){
	//	  std::cout<<map.n << "in the cube of "<<map.ix<<" "<<map.iy<<" "<<map.iz<<std::endl;
		  DenMF.push_back(map);}
	}

	int index=Boundions.size();
	std::cout<<ions.size()<<" ions in total"<<std::endl;
	std::cout<<DenMF.size()<<" bound ions are found"<<std::endl;
  for (const auto &map : DenMF){
	  ++index;
double sumx  = 0.0;    
double sumy  = 0.0;
double sumz  = 0.0;
int  num_ion = 0;
   for ( auto ionp = ions.begin(); ionp !=ions.end();){
    if (ionp->ix==map.ix &&  ionp->iy==map.iy && ionp->iz==map.iz){
       sumx +=ionp->x;
       sumy +=ionp->y;
       sumz +=ionp->z;
       ionp=ions.erase(ionp);
     ++num_ion;
    }else{++ionp;}
   }
      double x = sumx/ (double)num_ion +targetframe.x;
      double y = sumy/ (double)num_ion +targetframe.y;
      double z = sumz/ (double)num_ion +targetframe.z;
    ATOM atom(index,iontype, iontype, chainID, index,x,y,z,0.00, 0.00,std::to_string(cs));
    Boundions.push_back(atom);
  }

//  std::cout<< "target xyz is " <<targetframe.x<<" "<<targetframe.y<<" "<<targetframe.z<<std::endl;
DenM.clear();
}





void citation(){
	std::cout<<GREEN<<"Please cite: "<<std::endl;
	std::cout<<"Sun, Shengjie, et al. \" HIT-2: Implementing machine learning algorithms to treat bound ions in biomolecules.\" Computational and Structural Biotechnology Journal 21 (2023): 1383-1389." <<std::endl;
	std::cout<<"Sun, Shengjie, et al. \"Hybrid method for representing ions in implicit solvation calculations.\" Computational and Structural Biotechnology Journal 19 (2021): 801-811."<<std::endl;
	std::cout<<"Sun, Shengjie, et al. \"HIT web server: A hybrid method to improve electrostatic calculations for biomolecules.\" Computational and Structural Biotechnology Journal 20 (2022): 1580-1583.   " <<std::endl;
	std::cout<<BLUE<<"We greatly appreciate your valued support and respect"<<RESET<<std::endl;

}


}
namespace ss = ShengjieSun;

#endif
