// amino_nucleic_acids.h
#ifndef RESIDUE_NAMES_H
#define RESIDUE_NAMES_H

#include <string>
#include <unordered_set>

#define RESET   "\033[0m"
#define RED     "\033[31m"
#define GREEN   "\033[32m"
#define YELLOW  "\033[33m"
#define BLUE    "\033[34m"
#define MAGENTA "\033[35m"
#define CYAN    "\033[36m"
#define WHITE   "\033[37m"
#define INITIAL_CUBE_SIZE  3 
#define END_CUBE_SIZE   10





// Amino acid names
const std::unordered_set<std::string> aminoAcids {
    "ALA",
    "ARG",
    "ASN",
    "ASP",
    "CYS",
    "GLN",
    "GLU",
    "GLY",
    "HIS",
    "ILE",
    "LEU",
    "LYS",
    "MET",
    "PHE",
    "PRO",
    "SER",
    "THR",
    "TRP",
    "TYR",
    "VAL",
    "ASX",  // Asparagine or Aspartic acid
    "GLX",  // Glutamine or Glutamic acid
    "HSD"   // Histidine with protonated sidechain nitrogen
};

// Nucleic acid names
const std::unordered_set<std::string> nucleicAcids {
    "DA",   // Deoxyadenosine
    "DC",   // Deoxycytidine
    "DG",   // Deoxyguanosine
    "DT",   // Deoxythymidine
    "A",    // Adenosine
    "C",    // Cytidine
    "G",    // Guanosine
    "U"     // Uridine
};

const std::unordered_set<std::string> Cation {
    "CAL",  //Ca2+ 
    "POT",  //K+ 
    "SOD",  //Na+
    "CU",   //copper
    "ZN",   //zinc
    "Na+",  
    "NA" ,  
    "MG"    //Mg2+

};

const std::unordered_set<std::string> Anion {
    "CLA",    // Cl-
    "F",	     // F
    "BR",     // Br
    "IOD",    //I-
    "Cl-",    // Cl- in Amber
};
#endif // RESIDUE_NAMES_H

