# include <stdio.h>
# include <math.h>
# include <stdlib.h>
# include <time.h>

void one_set(double *pre_set, double *ready_set);
void moving(double *frames,double *frames_pre, double *ready_set, int num_frame);
double one_step();
void moving_restrain(double *frames, double *frames_pre, double *ready_set, int num_frame,double *cubesize);
void one_set_restrain(double *pre_set, double *ready_set);
void output(double *a, double *b, double *c,int num_frame);
double gen_rand_normal(const double mean, const double std); 

int main (int *argc, char **argv){
double pre_set[614*3]={0};
double ready_set[614*3]={0};
//all ions one frame
double cubesize[20];
for (int i=0;i<20;i++){
  cubesize[i]=random()/(double)RAND_MAX*1.5;
}
int num_frame=atoi(argv[1]);
double* frames= (double*) calloc(3*614*num_frame,sizeof(double));
double* frames_pre= (double*) calloc(3*614*num_frame,sizeof(double));
one_set_restrain(pre_set,ready_set);
one_set(pre_set,ready_set);
moving_restrain(frames,frames_pre,ready_set,num_frame,cubesize);
moving(frames,frames_pre,ready_set,num_frame);
output(frames,ready_set,cubesize,num_frame);

free(frames);
free(frames_pre);
return 0;
}


void output(double *frames, double *ready_set, double *cubesize, int num_frame){

for (int i =0;i<num_frame;i++){
  for (int j=0;j<10;j++){
    printf("%6s%5d %4s %3s %1s%4d    ","HETATM",j,"SOD","SOD","I",j);
    for (int k=0;k<3;k++){
    printf("%8.3lf",*(frames+614*i*3+j*3+k));}
    printf("  0.00  0.00      IONS\n");}
  for (int j=10;j<20;j++){
    printf("%6s%5d %4s %3s %1s%4d    ","HETATM",j,"CLA","CLA","I",j);
    for (int k=0;k<3;k++){
    printf("%8.3lf",*(frames+614*i*3+j*3+k));}
    printf("  0.00  0.00      IONS\n");}
  for (int j=20;j<317;j++){
    printf("%6s%5d %4s %3s %1s%4d    ","HETATM",j,"SOD","SOD","I",j);
    for (int k=0;k<3;k++){
    printf("%8.3lf",*(frames+614*i*3+j*3+k));}
    printf("  0.00  0.00      IONS\n");}
  for (int j=317;j<614;j++){
    printf("%6s%5d %4s %3s %1s%4d    ","HETATM",j,"CLA","CLA","I",j);
    for (int k=0;k<3;k++){
    printf("%8.3lf",*(frames+614*i*3+j*3+k));}
    printf("  0.00  0.00      IONS\n");}
    
 printf("END\n");}

for (int i =0;i<20;i++){
      printf("REMARK the binding sites and radius are %lf\t%lf\t%lf\t%lf\n",*(ready_set+3*i),*(ready_set+3*i+1),*(ready_set+3*i+2),cubesize[i]);}


}

void moving_restrain(double *a, double *b, double *c, int num_frame, double *cubesize_p){
for (int i=0;i<num_frame;i++){
 for(int j =0 ; j<20; j++){
  double CS=*(cubesize_p+j);
  for (int k=0;k<RAND_MAX;k++){
  double r1=2*(random()-RAND_MAX/2)/(double)RAND_MAX;
  double r2=2*(random()-RAND_MAX/2)/(double)RAND_MAX;
  double r3=2*(random()-RAND_MAX/2)/(double)RAND_MAX;

//  printf("the ratio is %f\n",r);
//  double randdis=r1*CS;
  double xr=CS*r1;
  double yr=CS*r2;
  double zr=CS*r3;
  double distance=pow(xr,2)+pow(yr,2)+pow(zr,2);
  if(distance<pow(CS,2)){
  *(a+i*614*3+j*3)=*(c+j*3)+xr;
  *(a+i*614*3+j*3+1)=*(c+j*3+1)+yr;
  *(a+i*614*3+j*3+2)=*(c+j*3+2)+zr;
  break;
  }
  }
            }
           }
          } 

void moving(double *a, double *b, double *c, int num_frame){
for (int i=0;i<num_frame;i++){
 for(int j = 20 ; j<614; j++){
   if (i==0){
   for (int o = 0; o<3;o++){
    *(a+i*614*3+j*3+o)=*(c+j*3+o);
    *(b+i*614*3+j*3+o)=*(c+j*3+o);
    }
   }else{
   for (int k = 0; k<RAND_MAX; k++){ 
     for (int x = 0; x<3; x++){
       *(b+i*614*3+j*3+x)=*(a+(i-1)*614*3+j*3+x)+one_step();
     }
    int cri=0;
        if(*(b+i*614*3+j*3)<0){*(b+i*614*3+j*3)+=150.0;}
        if(*(b+i*614*3+j*3+1)<0){*(b+i*614*3+j*3+1)+=150.0;}
        if(*(b+i*614*3+j*3+2)<0){*(b+i*614*3+j*3+2)+=150.0;}
        if(*(b+i*614*3+j*3)>150){*(b+i*614*3+j*3)-=150.0;}
        if(*(b+i*614*3+j*3+1)>150){*(b+i*614*3+j*3+1)-=150.0;}
        if(*(b+i*614*3+j*3+2)>150){*(b+i*614*3+j*3+2)-=150.0;}
     for (int l=0;l<j;l++){
      double x=pow((*(b+i*614*3+j*3+0)-*(a+i*614*3+l*3+0)),2);
      double y=pow((*(b+i*614*3+j*3+1)-*(a+i*614*3+l*3+1)),2);
      double z=pow((*(b+i*614*3+j*3+2)-*(a+i*614*3+l*3+2)),2);
      if (sqrt(x+y+z) <=5){
       cri=1;
       break;}
      }
    if ( cri == 0){
    for (int z = 0; z<3;z++){
    *(a+i*614*3+j*3+z)=*(b+i*614*3+j*3+z);
    }  
    break;
      }
     }       
    }
   }
  }
 }


double one_step(){
////double step=(random()-RAND_MAX/2)/(double)RAND_MAX*10;//0-1 A moving distance;
//if (rand()-RAND_MAX/2==0){
//return 0;
//}else if(rand()-RAND_MAX/2<0){
//return -1*gen_rand_normal(0,0.6);
//}else{
//return gen_rand_normal(0,0.6);
//}
return gen_rand_normal(0,2);
}


void one_set_restrain(double *a, double* b){
srand(time(NULL));
for (int i = 0;i<20;i++){
 for (unsigned int j=0; j<RAND_MAX; j++){
   for (int k = 0; k<3; k++){
    *(a+3*i+k)=130*random()/(double)RAND_MAX+10.0;
   }
   int cri=0;
   for (int l=0;l<i;l++){
    double x=pow((*(b+l*3+0)-*(a+i*3+0)),2);
    double y=pow((*(b+l*3+1)-*(a+i*3+1)),2);
    double z=pow((*(b+l*3+2)-*(a+i*3+2)),2);
    if (sqrt(x+y+z) <=10){
     cri++;
    }
   }
    if (i==0 || cri == 0){
    *(b+i*3+0)=*(a+i*3+0);
    *(b+i*3+1)=*(a+i*3+1);
    *(b+i*3+2)=*(a+i*3+2);
    break;
   }
  }
 }
}


void one_set(double *a, double *b){
srand(time(NULL));
for (int i = 20;i<614;i++){
 for (unsigned int j=0; j<RAND_MAX; j++){
   for (int k = 0; k<3; k++){
    *(a+3*i+k)=150*random()/(double)RAND_MAX;
   }
   int cri=0;
   for (int l=0;l<i;l++){
    double x=pow((*(b+l*3+0)-*(a+i*3+0)),2);
    double y=pow((*(b+l*3+1)-*(a+i*3+1)),2);
    double z=pow((*(b+l*3+2)-*(a+i*3+2)),2);
    if (sqrt(x+y+z) <=5){
     cri++;
    }
   }
    if (i==0 || cri == 0){
    *(b+i*3+0)=*(a+i*3+0);
    *(b+i*3+1)=*(a+i*3+1);
    *(b+i*3+2)=*(a+i*3+2);
    break;
   }
  }
 }
}
double gen_rand_normal(const double mean, const double std) {
  double u1, u2, w;
  do {
    u1 = 2.0*(-0.5+((double) rand()/RAND_MAX));
    u2 = 2.0*(-0.5+((double) rand()/RAND_MAX));
    w = u1 * u1 + u2 * u2;
  }
  while ( w>=1.0 || w==0.0 );
  return mean + std * u1 * sqrt((-2.0*log(w))/w);
} 
